import "core-js/modules/es6.array.fill";
import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _possibleConstructorReturn from "@babel/runtime/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/getPrototypeOf";
import _inherits from "@babel/runtime/helpers/inherits";
import _assertThisInitialized from "@babel/runtime/helpers/assertThisInitialized";
import _defineProperty from "@babel/runtime/helpers/defineProperty";

var _dec, _dec2, _class, _class2, _temp;

/**
 * @license
 * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
 */
import React, { Component } from 'react';
import PropTypes from 'prop-types';
import SwipeableViews from 'react-swipeable-views';
import { autoPlay } from 'react-swipeable-views-utils';
import withStyles from '@material-ui/core/styles/withStyles';
import ChevronLeft from '@material-ui/icons/ChevronLeft';
import ChevronRight from '@material-ui/icons/ChevronRight';
import IconButton from '@material-ui/core/IconButton';
import { fade } from '@material-ui/core/styles/colorManipulator';
import classnames from 'classnames';
import { inject, observer } from 'mobx-react';
import AmpCarousel from './amp/AmpCarousel';
var AutoPlaySwipeableViews = autoPlay(SwipeableViews);
export var styles = function styles(theme) {
  return {
    root: {
      display: 'flex',
      flexDirection: 'column',
      position: 'relative',
      '& img': {
        display: 'block'
      }
    },
    swipeWrap: {
      position: 'relative',
      overflow: 'hidden',
      flex: 1,
      '& .react-swipeable-view-container, & > div:first-child': {
        height: '100%'
      }
    },
    arrows: _defineProperty({}, theme.breakpoints.down('xs'), {
      display: 'none'
    }),
    arrow: {
      position: 'absolute',
      top: '50%',
      marginTop: '-24px'
    },
    leftArrow: {
      left: 0
    },
    rightArrow: {
      right: 0
    },
    icon: {
      height: '30px',
      width: '30px'
    },
    dot: {
      backgroundColor: fade(theme.palette.text.primary, 0.25),
      width: 8,
      height: 8,
      borderWidth: '1px',
      borderStyle: 'solid',
      borderColor: theme.palette.background.paper,
      borderRadius: '50%',
      display: 'inline-block',
      margin: '0 2px',
      // Same duration as SwipeableViews animation
      transitionDuration: '0.35s'
    },
    dotSelected: {
      backgroundColor: theme.palette.text.primary
    },
    dots: {
      position: 'absolute',
      bottom: '5px',
      textAlign: 'center',
      width: '100%'
    },
    indicator: {
      display: 'none'
    }
  };
};
var Carousel = (_dec = withStyles(styles, {
  name: 'RSFCarousel'
}), _dec2 = inject('app'), _dec(_class = _dec2(_class = observer(_class = (_temp = _class2 =
/*#__PURE__*/
function (_Component) {
  _inherits(Carousel, _Component);

  function Carousel() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, Carousel);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(Carousel)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "state", {});

    return _this;
  }

  _createClass(Carousel, [{
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      if (this.disposeReaction) {
        this.disposeReaction();
      }
    }
  }, {
    key: "renderDot",
    value: function renderDot(index) {
      var classes = classnames(this.props.classes.dot, _defineProperty({}, this.props.classes.dotSelected, index === this.state.selectedIndex));
      return React.createElement("div", {
        key: index,
        className: classes
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props = this.props,
          app = _this$props.app,
          classes = _this$props.classes,
          className = _this$props.className,
          arrows = _this$props.arrows,
          indicators = _this$props.indicators,
          style = _this$props.style,
          children = _this$props.children,
          autoplay = _this$props.autoplay,
          interval = _this$props.interval,
          direction = _this$props.direction,
          inset = _this$props.inset,
          slideSpacing = _this$props.slideSpacing;
      if (app.amp) return React.createElement(AmpCarousel, this.props);
      var selectedIndex = this.state.selectedIndex;
      var slideCount = React.Children.count(children);
      var Tag = autoplay ? AutoPlaySwipeableViews : SwipeableViews;
      return React.createElement("div", {
        className: classnames(className, classes.root),
        style: style
      }, React.createElement("div", {
        className: classes.swipeWrap
      }, React.createElement(Tag, {
        index: selectedIndex,
        onChangeIndex: function onChangeIndex(i) {
          return _this2.setState({
            selectedIndex: i
          });
        },
        direction: direction,
        interval: interval,
        slideStyle: {
          padding: "0 ".concat(slideSpacing, "px")
        },
        style: {
          padding: "0 ".concat(inset, "px")
        }
      }, children), arrows && React.createElement("div", {
        className: classes.arrows
      }, selectedIndex !== 0 && React.createElement(IconButton, {
        className: classnames(classes.arrow, classes.leftArrow),
        onClick: function onClick() {
          return _this2.setState({
            selectedIndex: selectedIndex - 1
          });
        }
      }, React.createElement(ChevronLeft, {
        classes: {
          root: classes.icon
        }
      })), selectedIndex !== slideCount - 1 && React.createElement(IconButton, {
        className: classnames(classes.arrow, classes.rightArrow),
        onClick: function onClick() {
          return _this2.setState({
            selectedIndex: selectedIndex + 1
          });
        }
      }, React.createElement(ChevronRight, {
        classes: {
          root: classes.icon
        }
      }))), indicators && React.createElement("div", {
        className: classes.dots
      }, Array(slideCount).fill(0).map(function (_, index) {
        return _this2.renderDot(index);
      }))));
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(nextProps, prevState) {
      var nextState = {
        selectedIndex: nextProps.selectedIndex != null ? nextProps.selectedIndex : prevState.selectedIndex || 0
      };

      if (prevState.selectedIndex == null) {
        return nextState;
      } else {
        return null;
      }
    }
  }]);

  return Carousel;
}(Component), _defineProperty(_class2, "propTypes", {
  /**
   * Display left/right arrows for navigating through slides
   */
  arrows: PropTypes.bool,

  /**
   * Display indicator dots at the bottom of the component
   */
  indicators: PropTypes.bool,

  /*
   * Option to manually set the selected index
   */
  selectedIndex: PropTypes.number,

  /**
   * If false, the auto play behavior is disabled
   */
  autoplay: PropTypes.bool,

  /**
   * This is the auto play direction
   */
  direction: PropTypes.string,

  /**
   * Delay between auto play transitions (in ms)
   */
  interval: PropTypes.number,

  /**
   * Amount of pixels to pad the slide container
   */
  inset: PropTypes.number,

  /**
   * Amount of pixels of spacing between each slide
   */
  slideSpacing: PropTypes.number
}), _defineProperty(_class2, "defaultProps", {
  arrows: true,
  indicators: false,
  autoplay: false,
  direction: 'incremental',
  interval: 3000,
  inset: 0,
  slideSpacing: 0
}), _temp)) || _class) || _class) || _class);
export { Carousel as default };
//# sourceMappingURL=Carousel.js.map