import _extends from "@babel/runtime/helpers/extends";
import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _possibleConstructorReturn from "@babel/runtime/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/getPrototypeOf";
import _inherits from "@babel/runtime/helpers/inherits";
import _assertThisInitialized from "@babel/runtime/helpers/assertThisInitialized";
import _objectSpread from "@babel/runtime/helpers/objectSpread";
import "core-js/modules/es6.function.name";
import _defineProperty from "@babel/runtime/helpers/defineProperty";

var _dec, _dec2, _class, _class2, _temp;

/**
 * @license
 * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
 */
import React, { Component } from 'react';
import PropTypes from 'prop-types';
import SwipeableViews from 'react-swipeable-views';
import withStyles from '@material-ui/core/styles/withStyles';
import ChevronLeft from '@material-ui/icons/ChevronLeft';
import ChevronRight from '@material-ui/icons/ChevronRight';
import IconButton from '@material-ui/core/IconButton';
import Portal from '@material-ui/core/Portal';
import { fade } from '@material-ui/core/styles/colorManipulator';
import classnames from 'classnames';
import { ReactPinchZoomPan } from 'react-pinch-zoom-pan';
import TabsRow from './TabsRow';
import analytics from './analytics';
import { inject, observer } from 'mobx-react';
import AmpImageSwitcher from './amp/AmpImageSwitcher';
import LoadMask from './LoadMask';
import Image from './Image';
import Video from './Video';
import isEqual from 'lodash/isEqual';
var paletteIconTextColor = '#77726D';
var mediaPropType = PropTypes.shape({
  src: PropTypes.string.isRequired,
  alt: PropTypes.string,
  video: PropTypes.bool
});
export var styles = function styles(theme) {
  return {
    root: {
      display: 'flex',
      flexDirection: 'column',
      position: 'relative',
      '& img': {
        display: 'block'
      }
    },
    swipeWrap: {
      position: 'relative',
      overflow: 'hidden',
      flex: 1,
      '& .react-swipeable-view-container, & > div:first-child': {
        height: '100%'
      }
    },
    imageWrap: {
      height: '100%',
      width: '100%',
      display: 'flex',
      justifyContent: 'center',
      alignItems: 'stretch',
      '& img': {
        maxHeight: '100%',
        maxWidth: '100%',
        objectFit: 'contain'
      }
    },
    thumbsTitle: {
      textTransform: 'uppercase'
    },
    productThumb: {
      position: 'absolute',
      top: 0,
      left: 0,
      right: 0,
      bottom: 0
    },
    thumbs: {
      marginTop: "".concat(theme.margins.container, "px")
    },
    thumbnail: {
      paddingBottom: '8px',
      margin: '0 2px',
      boxSizing: 'content-box',
      height: '50px',
      width: '50px'
    },
    activeThumbs: {
      position: 'absolute',
      width: '100%',
      bottom: '20px'
    },
    selected: {
      borderColor: '#D0D0D0'
    },
    arrows: _defineProperty({}, theme.breakpoints.down('xs'), {
      display: 'none'
    }),
    arrow: {
      position: 'absolute',
      top: '50%',
      marginTop: '-24px'
    },
    leftArrow: {
      left: 0
    },
    rightArrow: {
      right: 0
    },
    icon: {
      height: '30px',
      width: '30px'
    },
    dot: {
      backgroundColor: fade(theme.palette.text.primary, 0.25),
      width: 8,
      height: 8,
      borderWidth: '1px',
      borderStyle: 'solid',
      borderColor: theme.palette.background.paper,
      borderRadius: '50%',
      display: 'inline-block',
      margin: '0 2px',
      // Same duration as SwipeableViews animation
      transitionDuration: '0.35s'
    },
    dotSelected: {
      backgroundColor: theme.palette.text.primary
    },
    dots: {
      position: 'absolute',
      bottom: '5px',
      textAlign: 'center',
      width: '100%'
    },
    viewerToggle: {
      transform: 'scale(0.4)',
      position: 'absolute',
      top: 0,
      right: 0,
      background: fade(theme.palette.text.icon || paletteIconTextColor, 0.4),
      borderRadius: '50%',
      width: '100px',
      height: '100px',
      transitionDuration: '0.5s',
      '-webkit-tap-highlight-color': 'rgba(0, 0, 0, 0)'
    },
    viewerActive: {
      transform: 'scale(0.4) rotateZ(45deg)'
    },
    viewerOverlay: {
      position: 'fixed',
      top: 0,
      left: 0,
      width: '100%',
      height: '100%',
      background: theme.palette.background.paper,
      zIndex: 9999,
      transitionDuration: '0.5s',
      transform: 'translateY(100%)',
      visibility: 'hidden',
      // prevents lightbox from showing near the bottom of screen when browser controls hide on ios
      '& img': {
        margin: 'auto',
        maxHeight: '100%',
        maxWidth: '100%'
      },
      // Hack to fix root div height of pan/zoom/pinch container
      '& > div:first-child': {
        height: '100%'
      }
    },
    viewerOverlayActive: {
      transform: 'translateY(0%)',
      visibility: 'visible'
    },
    tabsRowRoot: {
      boxShadow: 'none'
    },
    tabScroller: _defineProperty({}, theme.breakpoints.down('xs'), {
      padding: "0 ".concat(theme.margins.container, "px")
    }),
    indicator: {
      display: 'none'
    },
    mask: {
      opacity: '0.8'
    },
    playButton: {
      '&:after': {
        color: 'white',
        content: '"►"',
        position: 'absolute',
        left: 'calc(50% - 24px)',
        top: 'calc(50% - 24px)',
        fontSize: '48px'
      }
    },
    playing: {
      '&:after': {
        display: 'none'
      }
    }
  };
};
/**
 * A swipeable image selector suitable for PDPs
 */

var ImageSwitcher = (_dec = withStyles(styles, {
  name: 'RSFImageSwitcher'
}), _dec2 = inject('app'), _dec(_class = _dec2(_class = observer(_class = (_temp = _class2 =
/*#__PURE__*/
function (_Component) {
  _inherits(ImageSwitcher, _Component);

  function ImageSwitcher() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, ImageSwitcher);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(ImageSwitcher)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "state", {
      fullSizeImagesLoaded: true,
      viewerActive: false,
      playingVideo: false
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "onFullSizeImagesLoaded", function () {
      _this.setState({
        fullSizeImagesLoaded: true
      });

      _this.props.app.applyState({
        loadingProduct: null
      });
    });

    return _this;
  }

  _createClass(ImageSwitcher, [{
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      if (this.disposeReaction) {
        this.disposeReaction();
      }
    }
  }, {
    key: "renderViewerToggle",
    value: function renderViewerToggle() {
      var _this2 = this;

      return React.createElement("div", {
        onClick: function onClick() {
          return _this2.toggleViewer();
        },
        className: classnames(this.props.classes.viewerToggle, _defineProperty({}, this.props.classes.viewerActive, this.state.viewerActive))
      }, React.createElement("svg", {
        width: "100",
        height: "100",
        viewBox: "0 0 100 100"
      }, React.createElement("line", {
        x1: "50",
        y1: "25",
        x2: "50",
        y2: "75",
        strokeWidth: "4",
        stroke: "white"
      }), React.createElement("line", {
        x1: "25",
        y1: "50",
        x2: "75",
        y2: "50",
        strokeWidth: "4",
        stroke: "white"
      })));
    }
  }, {
    key: "toggleViewer",
    value: function toggleViewer() {
      if (this.state.viewerActive) {
        document.body.classList.remove('moov-modal');
      } else {
        document.body.classList.add('moov-modal');
      }

      this.setState({
        viewerActive: !this.state.viewerActive
      });
    }
  }, {
    key: "renderDot",
    value: function renderDot(index) {
      var classes = classnames(this.props.classes.dot, _defineProperty({}, this.props.classes.dotSelected, index === this.state.selectedIndex));
      return React.createElement("div", {
        key: index,
        className: classes
      });
    }
  }, {
    key: "renderThumbnails",
    value: function renderThumbnails() {
      var _this3 = this;

      var _this$props = this.props,
          classes = _this$props.classes,
          thumbnailsTitle = _this$props.thumbnailsTitle,
          notFoundSrc = _this$props.notFoundSrc,
          thumbnailImageProps = _this$props.thumbnailImageProps;
      var thumbnails = this.state.thumbnails;
      var modifiedThumbs = thumbnails && thumbnails.map(function (_ref) {
        var src = _ref.src,
            alt = _ref.alt;
        return {
          imageUrl: src,
          alt: alt
        };
      });
      var _this$state = this.state,
          viewerActive = _this$state.viewerActive,
          selectedIndex = _this$state.selectedIndex;
      return thumbnails && thumbnails.length > 0 && React.createElement("div", {
        className: classnames(classes.thumbs, _defineProperty({}, classes.activeThumbs, viewerActive))
      }, React.createElement("div", {
        className: "field"
      }, React.createElement("label", {
        className: classes.thumbsTitle
      }, thumbnailsTitle)), React.createElement(TabsRow, {
        classes: {
          scroller: classes.tabScroller,
          root: classes.tabsRowRoot
        },
        imageProps: _objectSpread({
          className: classes.thumbnail,
          notFoundSrc: notFoundSrc,
          fill: true
        }, thumbnailImageProps),
        centered: true,
        initialSelectedIdx: selectedIndex,
        onTabChange: function onTabChange(e, selectedIndex) {
          return _this3.setState({
            selectedIndex: selectedIndex,
            playingVideo: false
          });
        },
        items: modifiedThumbs
      }));
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps, prevState) {
      if (prevState && prevState.selectedIndex && prevState.selectedIndex !== this.state.selectedIndex && this.props.product) {
        analytics.fire('imageSwitched', {
          product: this.props.product,
          imageUrl: this.props.images[this.state.selectedIndex]
        });
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this4 = this;

      var _this$props2 = this.props,
          app = _this$props2.app,
          product = _this$props2.product,
          classes = _this$props2.classes,
          className = _this$props2.className,
          arrows = _this$props2.arrows,
          indicators = _this$props2.indicators,
          style = _this$props2.style,
          reactPinchZoomPanOptions = _this$props2.reactPinchZoomPanOptions,
          loadingThumbnailProps = _this$props2.loadingThumbnailProps,
          imageProps = _this$props2.imageProps,
          viewerThumbnailsOnly = _this$props2.viewerThumbnailsOnly,
          notFoundSrc = _this$props2.notFoundSrc;
      var _this$state2 = this.state,
          fullSizeImagesLoaded = _this$state2.fullSizeImagesLoaded,
          images = _this$state2.images,
          thumbnails = _this$state2.thumbnails;

      if (app.amp) {
        return React.createElement(AmpImageSwitcher, {
          product: product,
          images: images,
          className: className,
          classes: {
            root: classes.root,
            dot: classes.dot,
            dots: classes.dots,
            dotSelected: classes.dotSelected,
            thumbnails: classes.thumbs
          },
          arrows: arrows,
          indicators: indicators,
          thumbnails: viewerThumbnailsOnly ? null : thumbnails
        });
      }

      var _this$state3 = this.state,
          selectedIndex = _this$state3.selectedIndex,
          viewerActive = _this$state3.viewerActive;
      var selectedImage = images[selectedIndex];
      var SelectedImageTag = selectedImage.video ? 'video' : 'img';
      return React.createElement("div", {
        className: classnames(className, classes.root),
        style: style
      }, React.createElement("div", {
        className: classes.swipeWrap
      }, React.createElement(SwipeableViews, {
        index: selectedIndex,
        onChangeIndex: function onChangeIndex(i) {
          return _this4.setState({
            selectedIndex: i
          });
        }
      }, images.map(function (_ref2, i) {
        var src = _ref2.src,
            alt = _ref2.alt,
            video = _ref2.video;
        return React.createElement("div", {
          key: i,
          className: classes.imageWrap
        }, video ? React.createElement(Video, {
          src: src,
          alt: alt
        }) : React.createElement(Image, _extends({
          key: src,
          notFoundSrc: notFoundSrc,
          src: src,
          alt: alt,
          onLoad: i === 0 ? _this4.onFullSizeImagesLoaded : null
        }, imageProps)));
      })), arrows && React.createElement("div", {
        className: classes.arrows
      }, selectedIndex !== 0 && React.createElement(IconButton, {
        className: classnames(classes.arrow, classes.leftArrow),
        onClick: function onClick() {
          return _this4.setState({
            selectedIndex: selectedIndex - 1
          });
        }
      }, React.createElement(ChevronLeft, {
        classes: {
          root: classes.icon
        }
      })), selectedIndex !== images.length - 1 && React.createElement(IconButton, {
        className: classnames(classes.arrow, classes.rightArrow),
        onClick: function onClick() {
          return _this4.setState({
            selectedIndex: selectedIndex + 1
          });
        }
      }, React.createElement(ChevronRight, {
        classes: {
          root: classes.icon
        }
      }))), indicators && React.createElement("div", {
        className: classes.dots
      }, images.map(function (_, index) {
        return _this4.renderDot(index);
      })), product && React.createElement(LoadMask, {
        show: product.loadingImages,
        className: classes.mask
      }), product && app.loadingProduct && app.loadingProduct.thumbnail && !fullSizeImagesLoaded && React.createElement(Image, _extends({
        src: app.loadingProduct.thumbnail,
        className: classes.productThumb
      }, loadingThumbnailProps, {
        fill: true
      })), React.createElement(Portal, null, React.createElement("div", {
        className: classnames(classes.viewerOverlay, _defineProperty({}, classes.viewerOverlayActive, viewerActive))
      }, React.createElement(ReactPinchZoomPan, _extends({}, reactPinchZoomPanOptions, {
        render: function render(obj) {
          var _classnames5;

          return React.createElement("div", {
            style: {
              overflow: 'hidden',
              position: 'relative',
              height: '100%'
            }
          }, React.createElement("div", {
            style: {
              display: 'flex',
              height: '100%'
            },
            className: classnames((_classnames5 = {}, _defineProperty(_classnames5, classes.playButton, selectedImage.video), _defineProperty(_classnames5, classes.playing, _this4.state.playingVideo), _classnames5)),
            onClick: function onClick() {
              if (_this4.selectedVideo) {
                if (_this4.selectedVideo.paused) {
                  _this4.selectedVideo.play();

                  _this4.setState({
                    playingVideo: true
                  });
                } else {
                  _this4.selectedVideo.pause();

                  _this4.setState({
                    playingVideo: false
                  });
                }
              }
            }
          }, selectedImage && React.createElement(SelectedImageTag, {
            ref: function ref(el) {
              if (selectedImage.video) {
                _this4.selectedVideo = el;
              }
            },
            src: selectedImage.zoomSrc || selectedImage.src,
            alt: selectedImage.alt,
            style: {
              width: '100%',
              height: 'auto',
              transform: "scale(".concat(obj.scale, ") translateY(").concat(obj.y, "px) translateX(").concat(obj.x, "px)")
            }
          })));
        }
      })), viewerActive && this.renderViewerToggle(), viewerActive && this.renderThumbnails())), !viewerActive && this.renderViewerToggle()), !viewerActive && !viewerThumbnailsOnly && this.renderThumbnails());
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(nextProps, prevState) {
      var nextState = {
        images: normalizeImages(nextProps, 'images'),
        thumbnails: normalizeImages(nextProps, 'thumbnails'),
        selectedIndex: nextProps.selectedIndex != null ? nextProps.selectedIndex : prevState.selectedIndex || 0
      };

      if (!prevState.images || !isEqual(nextState.images, prevState.images)) {
        // new images are loading in, show the loadingProduct.thumbnail
        nextState.fullSizeImagesLoaded = false; // reset the selected index to the first image

        if (!nextProps.selectedIndex) {
          nextState.selectedIndex = 0;
        }

        return nextState;
      } else if (prevState.selectedIndex == null) {
        return nextState;
      } else {
        return null;
      }
    }
  }]);

  return ImageSwitcher;
}(Component), _defineProperty(_class2, "propTypes", {
  /**
   * If specified, then the image_switched analytics event will be
   * fired when an image is selected and the product's images and thumbnails will
   * automatically be displayed.
   */
  product: PropTypes.object,

  /**
   * An array of (URL or image object) for the full size images
   */
  images: PropTypes.arrayOf(PropTypes.oneOfType([PropTypes.string, mediaPropType])).isRequired,

  /**
   * An array of thumbnails to display below the main image.  You can also
   * specify `false` to hide the thumbnails entirely.
   */
  thumbnails: PropTypes.oneOfType([PropTypes.bool, PropTypes.arrayOf(PropTypes.oneOfType([PropTypes.string, mediaPropType]))]),

  /**
   * Display left/right arrows for navigating through images
   */
  arrows: PropTypes.bool,

  /**
   * Display indicator dots at the bottom of the component
   */
  indicators: PropTypes.bool,

  /**
   * Optional title for thumbnails block
   */
  thumbnailsTitle: PropTypes.string,

  /*
   * Option to show thumbnails only when zoomed view is active
   */
  viewerThumbnailsOnly: PropTypes.bool,

  /**
   * Props to apply to the Image component used to display the product thumbnail while
   * the product data is loading
   */
  loadingThumbnailProps: PropTypes.object,

  /**
   * Props to apply to the thumbnail images
   */
  thumbnailImageProps: PropTypes.object,

  /**
   * Props to be added to the Image child components.
   */
  imageProps: PropTypes.object,

  /*
   * Option to manually set the selected index
   */
  selectedIndex: PropTypes.number,

  /**
   * The URL of image to load if an image fails to load
   */
  notFoundSrc: PropTypes.string,

  /**
   * Config options for the image viewer
   */
  reactPinchZoomPanOptions: PropTypes.shape({
    onPinchStart: PropTypes.func,
    onPinchStop: PropTypes.func,
    initialScale: PropTypes.number,
    maxScale: PropTypes.number
  }),

  /**
   * Set to true to always revert back to the first image when image URLs
   * are changed.  This behavior is automatically adopted when the `product`
   * prop is specified.
   */
  resetSelectionWhenImagesChange: PropTypes.bool
}), _defineProperty(_class2, "defaultProps", {
  images: [],
  thumbnails: [],
  viewerThumbnailsOnly: false,
  arrows: true,
  indicators: false,
  loadingThumbnailProps: {},
  imageProps: {},
  reactPinchZoomPanOptions: {
    maxScale: 3
  }
}), _temp)) || _class) || _class) || _class);
export { ImageSwitcher as default };
/**
 * Converts an array that can contain strings or MediaTypeModel instances into
 * an array of objects with src, alt, and video
 * @private
 * @param {Object} props
 * @param {String} key "images" or "thumbnails"
 */

function normalizeImages(props, key) {
  var product = props.product;
  var productName = product && product.name;
  var images = props[key];

  if (!images || !images.length) {
    images = product && product[key];
  }

  return !images ? [] : images.map(function (e) {
    if (typeof e === 'string') {
      return {
        src: e,
        alt: productName,
        video: false
      };
    } else {
      return _objectSpread({}, e, {
        alt: e.alt || productName
      });
    }
  });
}
//# sourceMappingURL=ImageSwitcher.js.map