import _extends from "@babel/runtime/helpers/extends";
import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _possibleConstructorReturn from "@babel/runtime/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/getPrototypeOf";
import _inherits from "@babel/runtime/helpers/inherits";
import _defineProperty from "@babel/runtime/helpers/defineProperty";

var _dec, _class, _class2, _temp;

/**
 * @license
 * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
 */
import React, { Component } from 'react';
import withStyles from '@material-ui/core/styles/withStyles';
import { fade } from '@material-ui/core/styles/colorManipulator';
import classnames from 'classnames';
import PropTypes from 'prop-types';
import { Helmet } from 'react-helmet';
import AmpState from './AmpState';
export var styles = function styles(theme) {
  return {
    root: {},
    dot: {
      backgroundColor: fade(theme.palette.text.primary, 0.25),
      width: 8,
      height: 8,
      borderWidth: '1px',
      borderStyle: 'solid',
      borderColor: theme.palette.background.paper,
      borderRadius: '50%',
      display: 'inline-block',
      margin: '0 2px',
      // Same duration as SwipeableViews animation
      transitionDuration: '0.35s'
    },
    dotSelected: {
      backgroundColor: theme.palette.text.primary
    },
    dots: {
      position: 'absolute',
      bottom: '5px',
      textAlign: 'center',
      width: '100%'
    }
  };
};
/**
 * A swipeable image selector suitable for PDPs
 */

var AmpCarousel = (_dec = withStyles(styles, {
  name: 'RSFAmpCarousel'
}), _dec(_class = (_temp = _class2 =
/*#__PURE__*/
function (_Component) {
  _inherits(AmpCarousel, _Component);

  function AmpCarousel() {
    _classCallCheck(this, AmpCarousel);

    return _possibleConstructorReturn(this, _getPrototypeOf(AmpCarousel).apply(this, arguments));
  }

  _createClass(AmpCarousel, [{
    key: "renderDot",
    value: function renderDot(index) {
      var _this$props = this.props,
          classes = _this$props.classes,
          ampStateProperty = _this$props.ampStateProperty;
      return React.createElement("div", {
        key: index,
        className: classnames(classes.dot, _defineProperty({}, classes.dotSelected, index === 0)),
        "amp-bind": "class=>rsfCarousel.".concat(ampStateProperty, " == ").concat(index, " ? '").concat(classes.dot, " ").concat(classes.dotSelected, "' : '").concat(classes.dot, "'")
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this = this;

      var _this$props2 = this.props,
          classes = _this$props2.classes,
          className = _this$props2.className,
          indicators = _this$props2.indicators,
          style = _this$props2.style,
          children = _this$props2.children,
          height = _this$props2.height,
          layout = _this$props2.layout,
          ampStateProperty = _this$props2.ampStateProperty,
          autoplay = _this$props2.autoplay,
          interval = _this$props2.interval,
          slideSpacing = _this$props2.slideSpacing,
          type = _this$props2.type;
      return React.createElement("div", {
        className: classnames(className, classes.root),
        style: style
      }, React.createElement(Helmet, null, React.createElement("script", {
        async: true,
        "custom-element": "amp-carousel",
        src: "https://cdn.ampproject.org/v0/amp-carousel-0.1.js"
      })), React.createElement(AmpState, {
        id: "rsfCarousel",
        initialState: _defineProperty({}, ampStateProperty, 0)
      }), React.createElement("amp-carousel", _extends({
        controls: true,
        height: height,
        layout: layout,
        type: type,
        on: "slideChange:AMP.setState({ rsfCarousel: { ".concat(ampStateProperty, ": event.index } })")
      }, autoplay ? {
        autoplay: autoplay,
        delay: interval
      } : {}), React.Children.map(children, function (e) {
        return React.createElement("div", {
          style: {
            padding: "0 ".concat(slideSpacing, "px")
          }
        }, e);
      })), indicators && React.createElement("div", {
        className: classes.dots
      }, React.Children.map(children, function (e, index) {
        return _this.renderDot(index);
      })));
    }
  }]);

  return AmpCarousel;
}(Component), _defineProperty(_class2, "propTypes", {
  /**
   * Display left/right arrows for navigating through images
   */
  arrows: PropTypes.bool,

  /**
   * Display indicator dots at the bottom of the component
   */
  indicators: PropTypes.bool,

  /*
   * Option to manually set the selected index
   */
  selectedIndex: PropTypes.number,

  /**
   * Height on carousel container, defaults to 200
   */
  height: PropTypes.number,

  /**
   * AMP layout type, defaults to "fixed-height"
   */
  layout: PropTypes.string,

  /**
   * The property in the amp state to bind to.  Defaults to "selectedIndex"
   */
  ampStateProperty: PropTypes.string,

  /**
   * If false, the auto play behavior is disabled
   */
  autoplay: PropTypes.bool,

  /**
   * Delay between auto play transitions (in ms)
   */
  interval: PropTypes.number,

  /**
   * Amount of pixels of spacing between each slide
   */
  slideSpacing: PropTypes.number,

  /**
   * AMP carousel type, defaults to "slides"
   */
  type: PropTypes.string
}), _defineProperty(_class2, "defaultProps", {
  arrows: true,
  indicators: false,
  height: 200,
  layout: 'fixed-height',
  ampStateProperty: 'selectedIndex',
  autoplay: false,
  interval: 3000,
  slideSpacing: 0,
  type: 'slides'
}), _temp)) || _class);
export { AmpCarousel as default };
//# sourceMappingURL=AmpCarousel.js.map