import _extends from "@babel/runtime/helpers/extends";
import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _possibleConstructorReturn from "@babel/runtime/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/getPrototypeOf";
import _inherits from "@babel/runtime/helpers/inherits";
import _defineProperty from "@babel/runtime/helpers/defineProperty";
import "core-js/modules/es6.string.anchor";

var _dec, _class;

/**
 * @license
 * Copyright © 2017-2019 Moov Corporation.  All rights reserved.
 */
import React, { Component } from 'react';
import Paper from '@material-ui/core/Paper';
import Close from '@material-ui/icons/Close';
import Fab from '@material-ui/core/Fab';
import classnames from 'classnames';
import { Helmet } from 'react-helmet';
import withStyleProps from '../withStyleProps';
var animationByAnchor = {
  top: 'fly-in-top',
  bottom: 'fly-in-bottom'
};
export var styles = function styles(_ref) {
  var theme = _ref.theme,
      anchor = _ref.anchor;
  return {
    backdrop: {
      top: '0',
      left: '0',
      right: '0',
      backgroundColor: 'rgba(0, 0, 0, 0.5)',
      bottom: '0',
      position: 'fixed',
      display: 'block',
      zIndex: theme.zIndex.amp.modal + 1
    },
    closeButton: {
      position: 'absolute',
      right: '10px',
      top: '-28px',
      zIndex: 1
    },
    hidden: {
      display: 'none'
    },
    lightbox: {
      zIndex: theme.zIndex.amp.modal + 2
    },
    container: _defineProperty({
      width: '100%',
      boxSizing: 'border-box',
      flexWrap: 'nowrap',
      display: 'flex',
      flexDirection: 'column',
      position: 'absolute',
      boxShadow: '0px 8px 10px -5px rgba(0,0,0,0.2), 0px 16px 24px 2px rgba(0,0,0,0.14), 0px 6px 30px 5px rgba(0,0,0,0.12)'
    }, anchor, 0),
    sidebar: {
      backgroundColor: 'white',
      boxShadow: '0px 8px 10px -5px rgba(0,0,0,0.2), 0px 16px 24px 2px rgba(0,0,0,0.14), 0px 6px 30px 5px rgba(0,0,0,0.12)',
      '& ~ div[class*="amphtml-sidebar-mask"]': {
        display: 'none'
      }
    }
  };
};
/**
 * An AMP compatible implementation of `react-storefront/Drawer`.  Do not use this component directly,
 * Use `DrawerButton` instead.
 */

var AmpDrawer = (_dec = withStyleProps(styles, {
  name: 'RSFAmpDrawer'
}), _dec(_class =
/*#__PURE__*/
function (_Component) {
  _inherits(AmpDrawer, _Component);

  function AmpDrawer() {
    _classCallCheck(this, AmpDrawer);

    return _possibleConstructorReturn(this, _getPrototypeOf(AmpDrawer).apply(this, arguments));
  }

  _createClass(AmpDrawer, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          classes = _this$props.classes,
          children = _this$props.children,
          ampStateId = _this$props.ampStateId,
          _this$props$anchor = _this$props.anchor,
          anchor = _this$props$anchor === void 0 ? 'bottom' : _this$props$anchor,
          _this$props$showClose = _this$props.showCloseButton,
          showCloseButton = _this$props$showClose === void 0 ? anchor === 'bottom' : _this$props$showClose,
          closeButtonProps = _this$props.closeButtonProps;

      if (anchor === 'left' || anchor === 'right') {
        return React.createElement(React.Fragment, null, React.createElement(Helmet, null, React.createElement("script", {
          async: true,
          "custom-element": "amp-sidebar",
          src: "https://cdn.ampproject.org/v0/amp-sidebar-0.1.js"
        })), React.createElement("div", {
          className: classes.hidden,
          role: "button",
          tabIndex: "0",
          on: "tap:".concat(ampStateId, ".close"),
          "amp-bind": "class=>".concat(ampStateId, ".open ? \"").concat(classnames(classes.backdrop), "\" : \"").concat(classes.hidden, "\"")
        }, React.createElement("amp-sidebar", {
          class: classes.sidebar,
          id: ampStateId,
          layout: "nodisplay",
          side: anchor,
          on: "sidebarClose:AMP.setState({ ".concat(ampStateId, ": { open: false } })")
        }, children)));
      }

      return React.createElement(React.Fragment, null, React.createElement(Helmet, null, React.createElement("script", {
        async: true,
        "custom-element": "amp-lightbox",
        src: "https://cdn.ampproject.org/v0/amp-lightbox-0.1.js"
      })), React.createElement("div", {
        className: classes.hidden,
        role: "button",
        tabIndex: "0",
        on: "tap:AMP.setState({ ".concat(ampStateId, ": { open: false }})"),
        "amp-bind": "class=>".concat(ampStateId, ".open ? \"").concat(classnames(classes.backdrop), "\" : \"").concat(classes.hidden, "\"")
      }, React.createElement("amp-lightbox", {
        class: classes.lightbox,
        "animate-in": animationByAnchor[anchor],
        "amp-bind": "open=>".concat(ampStateId, ".open"),
        layout: "nodisplay"
      }, React.createElement("div", {
        className: classes.container,
        role: "button",
        tabIndex: "0",
        on: "tap:AMP.setState({ ".concat(ampStateId, ": { open: true }})")
      }, showCloseButton && anchor === 'bottom' && React.createElement(Fab, _extends({
        color: "primary",
        className: classes.closeButton,
        on: "tap:AMP.setState({ ".concat(ampStateId, ": { open: false }})")
      }, closeButtonProps), React.createElement(Close, null)), React.createElement("div", {
        className: classes.content
      }, React.createElement(Paper, {
        square: true
      }, children))))));
    }
  }]);

  return AmpDrawer;
}(Component)) || _class);
export { AmpDrawer as default };
//# sourceMappingURL=AmpDrawer.js.map